; GUI #
include win64a.inc
IDR_MAINMENU	equ 30
ZZZ_SORTING	equ 0
ZZZ_RESET	equ 1
ZZZ_EXIT	equ 2
n = 137
.code
WinMain proc <15>
local msg:MSG	

	xor	ebx,ebx
	mov	esi,IMAGE_BASE
	mov	edi,offset ClassName
	mov	ecx,offset FileName
	invoke	LoadCursorFromFileA
	push	rax	;hIconSm
	push	rdi	;lpszClassName
	push	IDR_MAINMENU;lpszMenuName
	push	COLOR_WINDOWTEXT;hbrBackground
	push	rax	;hCursor
	push	rax    	;hIcon
	push	rsi	;hInstance
	push	rbx    	;cbClsExtra & cbWndExtra
	pushaddr WndProc  	;lpfnWndProc
	push	sizeof WNDCLASSEX;cbSize & style
	invoke	RegisterClassExA,esp	;addr WNDCLASSEX
    	invoke	CreateWindowExA,0,edi,edi,WS_OVERLAPPEDWINDOW \
	or WS_VISIBLE,100,100,1400,600,rcx,rcx,rsi,rcx
	mov	hwnd,rax
	invoke	GetMenu,eax
	mov	hMenu,rax
        invoke	ReDraw
	lea	edi,msg
@@:	invoke	GetMessageA,edi,NULL,0,0
	invoke	DispatchMessageA,edi
	jmp @b
WinMain endp
WndProc	proc <20> hWnd:qword,msg:qword,wParam:QWORD,lParam:QWORD
local	ps:PAINTSTRUCT
local	hDC:qword
local	rect:RECT
local	hPen:qword
local	buffer[100]:byte
local	randomValue:dword

	mov	hWnd,rcx
	mov	wParam,r8
	mov	lParam,r9

	cmp	edx,WM_CREATE
	je	wmCREATE
	cmp	edx,WM_DESTROY
	je	wmDESTROY
	cmp	edx,WM_CREATE
	je	wmBYE
	cmp	edx,WM_COMMAND
	je	wmCOMMAND
	cmp	edx,WM_PAINT
	je	wmPAINT
	cmp	edx,WM_USER+1
	je	wmUSER_1
	cmp	edx,WM_USER+2
	je	wmUSER_2
	leave
        jmp	NtdllDefWindowProc_
wmDESTROY:invoke RtlExitUserProcess,NULL
;-------------------------------------------------------
wmUSER_2:invoke	TerminateThread,hTread,0
	invoke	CloseHandle,hTread
	jmp	wmBYE
wmCREATE:invoke	GetSystemMetrics,SM_CXSCREEN
	mov	maxX,rax
        invoke	GetSystemMetrics,SM_CYSCREEN
	mov	maxY,rax
	invoke	GetDC,hWnd
	mov	hDC,rax
	invoke	CreateCompatibleDC,eax
	mov	memDC,rax
	invoke	CreateCompatibleBitmap,hDC,maxX,maxY
        invoke	SelectObject,memDC,eax
	invoke	GetStockObject,BLACK_BRUSH
        invoke	SelectObject,memDC,eax
	invoke	PatBlt,memDC,0,0,maxX,maxY,PATCOPY
	invoke	SetBkMode,memDC,TRANSPARENT
        invoke	ReleaseDC,hWnd,hDC
	jmp	wmBYE
wmUSER_1:invoke	PatBlt,memDC,0,0,maxX,maxY,PATCOPY
	lea	edx,rect
	invoke	GetClientRect,hWnd
	invoke	SetTextColor,memDC,0FFFFFFh
	invoke	SetBkColor,memDC,0
	mov	eax,countComp
	add	eax,countSwap
	je	@f

	mov	r9d,countComp
	mov	eax,countSwap
	mov	[rsp+20h],rax
	add	eax,r9d
	mov	[rsp+28h],rax
	xor	edx,edx
	mov	ecx,n
	div	ecx
	mov	[rsp+30h],rax
	mov	edx,offset fmt
	lea	ecx,buffer
	invoke	sprintf,,,n
	lea	r9d,buffer
	invoke	TextOut,memDC,0,0,,rax
;-----------------------
@@:	xor	edi,edi
	mov	esi,14
@@:	mov	eax,array1[rdi*4]
	mov	r8d,color[rax*4]
	invoke	CreatePen,PS_SOLID,9
	invoke	SelectObject,memDC,eax
	mov	hPen,rax
	invoke	MoveToEx,memDC,esi,rect.bottom,0
	mov	r8d,rect.bottom
	sub	r8d,array1[rdi*4]
	invoke	LineTo,memDC,esi
	invoke	DeleteObject,hPen
	add	esi,10
	inc	edi
	cmp	edi,n
	jb	@b
	invoke	InvalidateRect,hWnd,0,1
	jmp	wmBYE
SORTING:invoke	EnableMenuItem,hMenu,ZZZ_SORTING,MF_GRAYED
	mov	eax,offset ThreadID;lpThreadId --> CreateThread   ID  p
	mov	[rsp+28h],rax
	mov	qword ptr [rsp+20h],NORMAL_PRIORITY_CLASS
        mov	r8d,offset ThreadProc0
        invoke	CreateThread,0,0,,0
	mov	hTread,rax
	jmp	wmBYE
wmCOMMAND:and	r8d,1111y;wParam
	cmp	r8d,ZZZ_EXIT
	ja	wmBYE
	jmp	handler[r8*8]

RESET:	invoke	ReDraw
	cmp	hTread,0
	jz      wmBYE
	invoke	TerminateThread,hTread,0
	invoke	CloseHandle,hTread
	and	hTread,0
	jmp	wmBYE
wmPAINT:lea	edx,ps
	invoke	BeginPaint;,hWnd
	mov	hDC,rax
        invoke	BitBlt,eax,0,0,maxX,maxY,memDC,0,0,SRCCOPY        
	lea	edx,ps
	invoke	EndPaint,hWnd
wmBYE:	mov	eax,TRUE
	leave
	ret
handler	dq SORTING,RESET,wmDESTROY
WndProc	endp
ReDraw proc
local	randomValue:dword

	and	countSwap,0
	and	countComp,0
	mov	edi,offset array1
@@:	lea	ecx,randomValue
	invoke	rand_s;eax=max=32767=2^{15}-1
	mov	eax,randomValue
	and	eax,111111111b
	stosd
	cmp	edi,offset array1+n*4
	jb	@b
	xor	eax,eax
	mov	ecx,n
	rep	stosd
        invoke	PostMessageA,hwnd,WM_USER+1,0,0
	invoke	EnableMenuItem,hMenu,ZZZ_SORTING,MF_ENABLED
	leave
	ret
ReDraw endp
Sort proc left:dword,number:dword
local	old_edi:dword
local	old_esi:dword
local	change:dword

	mov	old_esi,esi
	mov	old_edi,edi	
	mov	left,ecx
	dec	edx
	or	edx,edx
	jz	@f
	mov	number,edx
	xor	esi,esi
@0:	mov	edi,number
	and	change,0
@1:	mov	eax,[rcx+rdi*4]
	inc	countComp
	cmp	eax,[rcx+rdi*4-4]           ;j>i ?
	ja	@2
;swap(A[j-1],A[j])-------------------------
	or	change,1
	inc	countSwap
	mov	edx,eax
	mov	eax,[rcx+rdi*4-4]
	mov	[rcx+rdi*4-4],edx
	mov	[rcx+rdi*4],eax
@2:	dec	edi
	cmp	edi,esi
	ja	@1
	cmp	change,1
	jne	@f
	inc	esi
	cmp	esi,number
	jb	@0
@@:	mov	edi,old_edi
	mov	esi,old_esi
	leave
	ret
Sort endp
BucketSort proc left:dword,number:dword
local	max:dword

	mov	left,ecx
	mov	number,edx
;  
	mov	edi,offset bucket_count
	xor	eax,eax
	mov	ecx,128/4
	rep	stosd
;     
	mov	ecx,number
	mov	esi,left
@@:	lodsd
	shr	eax,2
	inc	bucket_count[rax]
	loop	@b
;     
	mov	ecx,128
	and	max,0
	xor	eax,eax
@@:	mov	al,bucket_count[rcx-1]
	inc	countComp
	cmp	eax,max
	jbe	@0
	mov	max,eax
@0:	loop	@b
;   
	mov	edx,max
	shl	edx,9;128  * max * 4 
	invoke	GlobalAlloc,GPTR
	mov	buckets,eax
;   
	mov	ecx,number
	mov	esi,left
	mov	edi,buckets
@1:	lodsd
	mov	ebx,eax
	shr	eax,2
	mul	max
@2:	inc	countComp
	cmp	dword ptr[rdi+rax*4],0;     
	jnz	@f;     
	mov	[rdi+rax*4],ebx
	jmp	@3
@@:	inc	eax
	jmp	@2
@3:	loop	@1
;  ,      ,   
	mov	edi,left
	mov	esi,buckets
	xor	ebx,ebx
@4:     cmp	bucket_count[rbx],0
	jz	@5;   --  
	mov	eax,ebx
	mul	max
	mov	dl,bucket_count[rbx]
	lea	ecx,[rsi+rax*4]
	invoke	Sort
	push	rbx
	movzx	ecx,bucket_count[rbx]
	mov	eax,ebx
	mul	max
	mov	ebx,eax
@@:	mov	eax,[rsi+rbx*4]
	stosd;    
	inc	ebx
	loop	@b
	pop	rbx
@5:	invoke	PostMessageA,hwnd,WM_USER+1,0,0
	invoke	Sleep,50
	inc	ebx
	cmp	ebx,128
	jb	@4
;-----------------------------------------------------
	mov	ecx,buckets
	invoke	GlobalFree
exit_:	leave
	ret
BucketSort endp
ThreadProc0 proc dummy:dword
	and	countComp,0
	and	countSwap,0
	mov	ecx,offset array1
	invoke	BucketSort,,n
	invoke	PostMessageA,hwnd,WM_USER+2,0,0
	invoke	Sleep,50
	leave
	ret
ThreadProc0 endp
color dd 80FFh,82FDh,84FBh,86F9h,88F7h,8AF5h,8CF3h,8EF1h,90EFh,92EDh,94EBh,96E9h
dd 98E7h,9AE5h,9CE3h,9EE1h,0A0DFh,0A2DDh,0A4DBh,0A6D9h,0A8D7h,0AAD5h,0ACD3h
dd 0AED1h,0B0CFh,0B2CDh,0B4CBh,0B6C9h,0B8C7h,0BAC5h,0BCC3h,0BEC1h,0C0BFh,0C2BDh
dd 0C4BBh,0C6B9h,0C8B7h,0CAB5h,0CCB3h,0CEB1h,0D0AFh,0D2ADh,0D4ABh,0D6A9h,0D8A7h
dd 0DAA5h,0DCA3h,0DEA1h,0E09Fh,0E29Dh,0E49Bh,0E699h,0E897h,0EA95h,0EC93h,0EE91h
dd 0F08Fh,0F28Dh,0F48Bh,0F689h,0F887h,0FA85h,0FC83h,0FE81h,0FF7Fh,2FF7Dh,4FF7Bh
dd 6FF79h,8FF77h,0AFF75h,0CFF73h,0EFF71h,10FF6Fh,12FF6Dh,14FF6Bh,16FF69h,18FF67h
dd 1AFF65h,1CFF63h,1EFF61h,20FF5Fh,22FF5Dh,24FF5Bh,26FF59h,28FF57h,2AFF55h
dd 2CFF53h,2EFF51h,30FF4Fh,32FF4Dh,34FF4Bh,36FF49h,38FF47h,3AFF45h,3CFF43h
dd 3EFF41h,40FF3Fh,42FD3Dh,44FB3Bh,46F939h,48F737h,4AF535h,4CF333h,4EF131h
dd 50EF2Fh,52ED2Dh,54EB2Bh,56E929h,58E727h,5AE525h,5CE323h,5EE121h,60DF1Fh
dd 62DD1Dh,64DB1Bh,66D919h,68D717h,6AD515h,6CD313h,6ED111h,70CF0Fh,72CD0Dh
dd 74CB0Bh,76C909h,78C707h,7AC505h,7CC303h,7EC101h,80C000h,81BF00h,82BE00h
dd 83BD00h,84BC00h,85BB00h,86BA00h,87B900h,88B800h,89B700h,8AB600h,8BB500h
dd 8CB400h,8DB300h,8EB200h,8FB100h,90B000h,91AF00h,92AE00h,93AD00h,94AC00h
dd 95AB00h,96AA00h,97A900h,98A800h,99A700h,9AA600h,9BA500h,9CA400h,9DA300h
dd 9EA200h,9FA100h,9FA000h,0A09F00h,0A19E00h,0A29D00h,0A39C00h,0A49B00h
dd 0A59A00h,0A69900h,0A79800h,0A89700h,0A99600h,0AA9500h,0AB9400h,0AC9300h
dd 0AD9200h,0AE9100h,0AF9000h,0B08F00h,0B18E00h,0B28D00h,0B38C00h,0B48B00h
dd 0B58A00h,0B68900h,0B78800h,0B88700h,0B98600h,0BA8500h,0BB8400h,0BC8300h
dd 0BD8200h,0BE8100h,0BE8000h,0BF7F00h,0C07E00h,0C17D00h,0C27C00h,0C37B00h
dd 0C47A00h,0C57900h,0C67800h,0C77700h,0C87600h,0C97500h,0CA7400h,0CB7300h
dd 0CC7200h,0CD7100h,0CE7000h,0CF6F00h,0D06E00h,0D16D00h,0D26C00h,0D36B00h
dd 0D46A00h,0D56900h,0D66800h,0D76700h,0D86600h,0D96500h,0DA6400h,0DB6300h
dd 0DC6200h,0DD6100h,0DD6000h,0DD5F01h,0DD5E02h,0DD5D03h,0DD5C04h,0DD5B05h
dd 0DD5A06h,0DD5907h,0DD5808h,0DD5709h,0DD560Ah,0DD550Bh,0DD540Ch,0DD530Dh
dd 0DD520Eh,0DD510Fh,0DD5010h,0DD4F11h,0DD4E12h,0DD4D13h,0DD4C14h,0DD4B15h
dd 0DD4A16h,0DD4917h,0DD4818h,0DD4719h,0DD461Ah,0DD451Bh,0DD441Ch,0DD431Dh
dd 0DD421Eh,0DD411Fh,0DD4020h,0DC3F21h,0DB3E22h,0DA3D23h,0D93C24h,0D83B25h
dd 0D73A26h,0D63927h,0D53828h,0D43729h,0D3362Ah,0D2352Bh,0D1342Ch,0D0332Dh
dd 0CF322Eh,0CE312Fh,0CD3030h,0CC2F31h,0CB2E32h,0CA2D33h,0C92C34h,0C82B35h
dd 0C72A36h,0C62937h,0C52838h,0C42739h,0C3263Ah,0C2253Bh,0C1243Ch,0C0233Dh
dd 0BF223Eh,0BE213Fh,0BE2040h,0BD1F41h,0BC1E42h,0BB1D43h,0BA1C44h,0B91B45h
dd 0B81A46h,0B71947h,0B61848h,0B51749h,0B4164Ah,0B3154Bh,0B2144Ch,0B1134Dh
dd 0B0124Eh,0AF114Fh,0AE1050h,0AD0F51h,0AC0E52h,0AB0D53h,0AA0C54h,0A90B55h
dd 0A90056h,0A80057h,0A70058h,0A60059h,0A5005Ah,0A4005Bh,0A3005Ch,0A2005Dh
dd 0A1005Eh,0A0005Fh,9F0060h,9E0061h,9D0062h,9C0063h,9B0064h,9A0065h,990066h
dd 980067h,970068h,960069h,95006Ah,94006Bh,93006Ch,92006Dh,91006Eh,90006Fh
dd 8F0070h,8E0071h,8D0072h,8C0073h,8B0074h,8A0075h,8A0072h,890072h,880072h
dd 870072h,860072h,850072h,840072h,830072h,820072h,810072h,800072h,7F0072h
dd 7E0072h,7D0072h,7C0072h,7B0072h,7A0072h,790072h,780072h,770072h,760072h
dd 750072h,740072h,730072h,720072h,710072h,700072h,6F0072h,6E0072h,6D0072h
dd 6C0072h,6B0072h,6B0072h,6A0073h,690074h,680075h,670076h,660077h,650078h
dd 640079h,63007Ah,62007Bh,61007Ch,60007Dh,5F007Eh,5E007Fh,5D0080h,5C0081h
dd 5B0082h,5A0083h,590084h,580085h,570086h,560087h,550088h,540089h,53008Ah
dd 52008Bh,51008Ch,50008Dh,4F008Eh,4E008Fh,4D0090h,4C0091h,4C0092h,4B0093h
dd 4A0094h,490095h,480096h,470097h,460098h,450099h,44009Ah,43009Bh,42009Ch
dd 41009Dh,40009Eh,3F009Fh,3E00A0h,3D00A1h,3C00A2h,3B00A3h,3A00A4h,3900A5h
dd 3800A6h,3700A7h,3600A8h,3500A9h,3400AAh,3300ABh,3200ACh,3100ADh,3000AEh
dd 2F00AFh,2E00B0h,2D00B1h,2D00B2h,2C00B3h,2B00B4h,2A00B5h,2900B6h,2800B7h
dd 2700B8h,2600B9h,2500BAh,2400BBh,2300BCh,2200BDh,2100BEh,2000BFh,1F00C0h
dd 1E00C1h,1D00C2h,1C00C3h,1B00C4h,1A00C5h,1900C6h,1800C7h,1700C8h,1600C9h
dd 1500CAh,1400CBh,1300CCh,1200CDh,1100CEh,1000CFh,0F00D0h,0E00D1h,3800CFh
dd 3700D0h,3600D1h,3500D2h,3400D3h,3300D4h,3200D5h,3100D6h,3000D7h,2F00D8h
dd 2E00D9h,2D00DAh,2C00DBh,2B00DCh,2A00DDh,2900DEh,2800DFh,2700E0h,2600E1h
dd 2500E2h,2400E3h,2300E4h,2200E5h,2100E6h,2000E7h,1F00E8h,1E00E9h,1D00EAh
dd 1C00EBh,1B00ECh,1A00EDh,1900EEh,1800EFh,1700F0h,1600F1h,1500F2h,1400F3h
dd 1300F4h,1200F5h,1100F6h,1000F7h,0F00F8h
;-----------------------------------------------------
.data
ClassName	db "Bucket Sort",0
FileName	db "br_Rabbit3.cur",0
fmt		db "Array i = %d, Comparisons = %d, Swaping = %d, Comparisons"
		db " + Swaping = %d = i * %d",0
hTread		dq 0
countComp	dd ?
countSwap	dd ?
hwnd		dq ?
ThreadID	dd ?
hMenu		dq ?
maxX		dq ?
maxY		dq ?
memDC		dq ?
bucket_count	db 128 dup(?)
array1		dd n dup(?)
buckets		dd ?
end